#include <pluginlib/class_list_macros.h>
#include <ros/ros.h>

#include "ultrasonic/Ultrasonic.h"

#include "car/ussDataMsg.h"

PLUGINLIB_EXPORT_CLASS(car::Ultrasonic, nodelet::Nodelet
);

namespace car
{
Ultrasonic::Ultrasonic(ros::NodeHandle & nh, std::string & name) : USS_SRF02(0x76), nh_(nh), name_(name)
{}

Ultrasonic::Ultrasonic()  : USS_SRF02(0x76)
{}

Ultrasonic::~Ultrasonic()
{}

void Ultrasonic::onInit()
{
    int dist = getDistance();
    
    NODELET_INFO("Ultrasonic::onInit -- START");
    ussData = nh_.advertise<ussDataMsg>("ussData", 1);
    main = boost::thread(
        [this]()
        {
            int counter = 0;
            ros::Rate rate{1};
            while (ros::ok())
            {
                ussDataMsg msg;
                msg.distance = counter++;
                ussData.publish(msg);
                rate.sleep();
            }
        });

    NODELET_INFO("Ultrasonic::onInit -- END");
}
}
